package org.n52.wps.client.jump;

import org.n52.wps.client.WPSClientSession;

import com.vividsolutions.jump.task.TaskMonitor;
import com.vividsolutions.jump.workbench.plugin.PlugInContext;
import com.vividsolutions.jump.workbench.plugin.ThreadedBasePlugIn;
import com.vividsolutions.jump.workbench.ui.GUIUtil;
import com.vividsolutions.jump.workbench.ui.MultiInputDialog;

public class WPSClientAddPlugIn extends ThreadedBasePlugIn {

	private static String INPUT_URL = "INPUT_URL";
	private MultiInputDialog dialog;
	
	public boolean execute(PlugInContext ctx) throws Exception {
		dialog = new MultiInputDialog(ctx.getWorkbenchFrame(),"Add WPS", true);
		dialog.addTextField(INPUT_URL, "http://localhost:8080/wps/WebProcessingService", 100, null, "please insert WPS URL");
		dialog.setVisible(true);
		if(!dialog.wasOKPressed()) {
			return false;
		}
		GUIUtil.centreOnScreen(dialog);
		return true;
	}

	public void initialize(PlugInContext ctx) throws Exception {
		ctx.getFeatureInstaller().addMainMenuItem(this, WPSClientExtension.WPS_CLIENT_MENU_PATH, "Add WPS", null, null);
	}

	public void run(TaskMonitor monitor, PlugInContext ctx) throws Exception {
		WPSClientSession client = (WPSClientSession)ctx.getWorkbenchContext().getBlackboard().get(WPSClientExtension.WPS_Client);
		String url = dialog.getText(INPUT_URL);
		if(client.serviceAlreadyRegistered(url)) {
			ctx.getWorkbenchFrame().warnUser("Service is already registered");
			return;
		}
		if(client.connect(url)) {
			ctx.getWorkbenchFrame().warnUser("Service successfully connected");
		}
		else {
			ctx.getWorkbenchFrame().warnUser("ERROR, service was not successfully conected!");
		}
	}
	
}
